/*******************************************************************************
 * 
 * jKiwi -- A virtual makeover and hairstyler application
 * Copyright (c) 2007-2008 Dan Mihai Ile, Maria Joao Roque Barbado Leal
 * 
 * This file is part of jKiwi.
 * 
 * jKiwi is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * jKiwi is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *******************************************************************************/

package tabs.hair;

import java.util.ArrayList;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;


/**
 * Instances of this class can be used
 * to parse a XML hair colors file
 */
//TODO a check for the XML file version should be implemented here
public class HairColorsXMLHandler extends DefaultHandler {

	/**
	 * The hair colors in the parsed XML file
	 */
	private ArrayList<HairColorData> hairColorsList = null;

	/**
	 * Creates a new instance of this class that is
	 * ready to parse a XML hair colors file
	 */
	public HairColorsXMLHandler() {
		initReadingVars();
	}

	/**
	 * Reset this instance's variables so that a new parsing can be made
	 */
	public void initReadingVars() {
		hairColorsList = new ArrayList<HairColorData>();
	}

	/**
	 * An {@link ArrayList} containing the parsed hair colors
	 * @return an {@link ArrayList} with the parsed hair colors
	 */
	public ArrayList<HairColorData> getHairColorsList() {
		return hairColorsList;
	}

	@Override
	public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
		if (qName.equalsIgnoreCase("color")) {
			hairColorsList.add(new HairColorData(attributes.getValue("blendingMode"),
					attributes.getValue("name"),
					attributes.getValue("channelRed"),
					attributes.getValue("channelGreen"),
					attributes.getValue("channelBlue")));
		}
	}
}